﻿using Assets.ETSI.ARF.ARF_World_Storage_API.Editor.Graph;
using ETSI.ARF.WorldStorage;
using ETSI.ARF.WorldStorage.UI;
using Org.OpenAPITools.Model;
using System;
using UnityEditor;
using UnityEngine;

namespace Assets.ETSI.ARF.ARF_World_Storage_API.Editor.Windows
{
    public class NodeEditorWindow : EditorWindow
    {
        public enum GraphEditorType
        {
            TRACKABLE,
            WORLDANCHOR,
            WORLDLINK
        }

        public GraphEditorType type;

        // UI stuffs
        private Vector2 scrollPos;
        static public NodeEditorWindow winSingleton;

        public static void ShowWindow(ARFNodeTrackable trackableNode)
        {
            Type inspectorType = Type.GetType("UnityEditor.InspectorWindow,UnityEditor.dll");
            winSingleton = GetWindow<NodeEditorWindow>("Trackable Editor", true, inspectorType);
            winSingleton.type = GraphEditorType.TRACKABLE;
        }

        public static void ShowWindow(ARFNodeWorldAnchor worldAnchorNode)
        {
            Type inspectorType = Type.GetType("UnityEditor.InspectorWindow,UnityEditor.dll");
            winSingleton = GetWindow<NodeEditorWindow>("Anchor Editor", true, inspectorType);
            winSingleton.type = GraphEditorType.WORLDANCHOR;
        }

        public static void ShowWindow(ARFEdgeLink graphEdge)
        {
            Type inspectorType = Type.GetType("UnityEditor.InspectorWindow,UnityEditor.dll");
            winSingleton = GetWindow<NodeEditorWindow>("Link Editor", true, inspectorType);
            winSingleton.type = GraphEditorType.WORLDLINK;
        }

        public void OnGUI()
        {

            scrollPos = EditorGUILayout.BeginScrollView(scrollPos, GUILayout.ExpandWidth(true));

            switch (type)
            {
                case GraphEditorType.WORLDLINK:
                    GUILayout.Label("link");
                    break;
                case GraphEditorType.TRACKABLE:
                    GUILayout.Label("tra");
                    break;
                case GraphEditorType.WORLDANCHOR:
                    GUILayout.Label("wa");
                    break;
                default:
                    break;
            }

            EditorGUILayout.EndScrollView();
        }
    }
}